module mydata_m
   
   implicit none
   
   private
   
   type, public :: mydata_t
      character(len=10) :: name
   contains
      private
      procedure, pass(dtv) :: write_unfmt => write_unfmt_mydata
      generic, public :: write(unformatted) => write_unfmt
   end type mydata_t
   
   type, extends(mydata_t), public :: myint_t
      integer :: nn
      integer, pointer :: xx(:)
   contains
      private
      procedure, pass(dtv) :: write_unfmt => write_unfmt_myint
   end type myint_t

contains

   subroutine write_unfmt_mydata(dtv, unit, iostat, iomsg)
   
      class(mydata_t), intent(in)     :: dtv
      integer, intent(in)             :: unit
      integer, intent(out)            :: iostat
      character(len=*), intent(inout) :: iomsg
      
      print *, 'in mydata'
      write(unit, iostat=iostat, iomsg=iomsg) dtv%name
      
   end subroutine write_unfmt_mydata
   
   subroutine write_unfmt_myint(dtv, unit, iostat, iomsg)
   
      class(myint_t), intent(in)      :: dtv
      integer, intent(in)             :: unit
      integer, intent(out)            :: iostat
      character(len=*), intent(inout) :: iomsg

      print *, 'in myint'
      write(unit, iostat=iostat, iomsg=iomsg) dtv%mydata_t
      write(unit, iostat=iostat, iomsg=iomsg) dtv%nn
      write(unit, iostat=iostat, iomsg=iomsg) dtv%xx(1:dtv%nn)
      
   end subroutine write_unfmt_myint

end module mydata_m

program test

   use mydata_m, only : mydata_t, myint_t
   
   implicit none

   type(mydata_t) :: dd
   type(myint_t) :: ii
   dd = mydata_t( 'xyz' )
   ii%name = 'abc'
   ii%nn = 100
   allocate(ii%xx(ii%nn))
   ii%xx = 5

   open(10, file='test.dat', form='unformatted')
   write(10) dd
   write(10) ii
   
end program test
